macro @VARS t,[a] {
 common
  if _#t in <_BYTE,_CHAR>
 forward
  DONE equ NO
  match _a(_b),a \{
    _a db _b
   \DONE equ YES \}
  match =NO,DONE \{
    a db ?       \} 
 common
  else if _#t in <_INTEGER,_LONGINT,_LONGWORD>
 forward
  DONE equ NO
  match _a(_b),a \{
    _a dd _b
   \DONE equ YES \}
  match =NO,DONE \{
    a dd ?       \} 
 common
  end if
}
macro @VAR [args] {
 common
  match _type:_list,args \{
   @VARS _type,_list
  \}
}

macro @BEGIN {}

macro @PROC [params]			; define STDCALL procedure
 { common
    local args,size,current
    match name arg, params
    \{ if used name
       name:
       virtual at ebp+8
       match =,args, arg \\{ defargs@proc args \\}
       match =all@args, all@args \{ defargs@proc arg \\}
       args = $ - (ebp+8)
       end virtual \}
    match =all@args, all@args
    \{ if used params
       params:
       args = 0
       all@args equ \}
    all@vars equ
    current = 0
    push ebp
    mov ebp,esp
    if size
     sub esp,size
    end if
    macro locals
    \{ virtual at ebp-size+current
       macro label . \\{ deflocal@proc .,: \\}
       struc db val \\{ deflocal@proc .,db val \\}
       struc dw val \\{ deflocal@proc .,dw val \\}
       struc dp val \\{ deflocal@proc .,dp val \\}
       struc dd val \\{ deflocal@proc .,dd val \\}
       struc dt val \\{ deflocal@proc .,dt val \\}
       struc dq val \\{ deflocal@proc .,dq val \\} \}
    macro endl
    \{ purge label
       restruc db,dw,dp,dd,dt,dq
       restruc byte,word,dword,pword,tword,qword
       current = $-(ebp-size)
       end virtual \}
    macro local [var]
    \{ \common locals
       \forward match varname:vartype,var \\{ varname vartype \\}
       \common endl \}
    macro return
    \{ leave
       if args
	retn args
       else
	retn
       end if \}
    macro finish@proc \{
        size = (((current-1) shr 2)+1) shl 2
      end if \}
    }

macro defargs@proc [arg]
 { common
    if ~ arg eq
   forward
     local ..arg,current@arg
     match argname:type, arg
      \{ current@arg equ argname
	 label ..arg type
	 argname equ ..arg
	 if qword eq type | pword eq type
	   dq
	 else
	   dd ?
	 end if \}
     match =current@arg,current@arg
      \{ current@arg equ arg
	 arg equ ..arg
	 ..arg dd ? \}
   common
     all@args equ current@arg
   forward
     restore current@arg
   common
    end if }

macro deflocal@proc name,def
 { match vars, all@vars \{ all@vars equ vars,name \}
   match ,all@vars \{ all@vars equ name \}
   local ..var
   name equ ..var
   ..var def }

macro @END
 { purge ret,locals,endl,local
   finish@proc
   purge finish@proc
   match all,all@args \{ restore all \}
   restore all@args
   match all,all@vars \{ restore all \} }

;------------------------------------------------------------

macro header a,[b] {
 common
  use32
  org 0
  db 'MENUET',a
 forward
  if b eq
   dd 0
  else
   dd b
  end if }

macro section name,[other] {
 align 4
 label name }

;------------------------------------------------------------

macro .end
{
  section @@END
}