const
  clBlack   = $00000000;
  clNavy    = $00000080;
  clGreen   = $00008000;
  clTeal    = $00008080;
  clMaroon  = $00800000;
  clPurple  = $00800080;
  clOlive   = $00808000;
  clSilver  = $00C0C0C0;
  clGray    = $00808080;
  clBlue    = $000000FF;
  clLime    = $0000FF00;
  clAqua    = $0000FFFF;
  clRed     = $00FF0000;
  clFuchsia = $00FF00FF;
  clYellow  = $00FFFF00;
  clWhite   = $00FFFFFF;

  WS_STYLE1 = $00000000;
  WS_TRANSP = $01000000;
  WS_STYLE2 = $02000000;
  WS_SKIN   = $03000000;

  PAINT_BEGIN = 1;
  PAINT_END   = 2;

procedure exit_program;
begin asm
  or   eax,-1
  int  0x40
end; end;

procedure paint(a: integer);
begin asm
  mov   eax,12
  mov   ebx,[__A]
  int   0x40
end; end;

procedure define_window(x,y,width,height,color1,color2,color3: integer);
begin asm
  xor  eax,eax
  mov  ebx,[__X]
  shl  ebx,16
  add  ebx,[__WIDTH]
  mov  ecx,[__Y]
  shl  ecx,16
  add  ecx,[__HEIGHT]
  mov  edx,[__COLOR1]
  mov  esi,[__COLOR2]
  mov  edi,[__COLOR3]
  int  0x40
end; end;

procedure define_button(x,y,width,height,id,color: integer);
begin asm
  mov  eax,8
  mov  ebx,[__X]
  shl  ebx,16
  add  ebx,[__WIDTH]
  mov  ecx,[__Y]
  shl  ecx,16
  add  ecx,[__HEIGHT]
  mov  edx,[__ID]
  mov  esi,[__COLOR]
  int  0x40
end; end;

function get_pressed_key(var id: integer): integer;
begin asm
  mov   eax,2
  int   0x40
; movzx dword[.__RESULT],al
  shr   eax,8
  mov   ebx,[__ID]
  mov   [ebx],eax
end; end;

function get_pressed_button(var id: integer): integer;
begin asm
  mov   eax,17
  int   0x40
; movzx dword[.__RESULT],al
  shr   eax,8
  mov   ebx,[__ID]
  mov   [ebx],eax
end; end;

function wait_for_event: integer;
begin asm
  mov  eax,10
  int  0x40
  mov  [.__RESULT],eax
end; end;

procedure draw_string(x,y,color: integer; s: string);
begin asm
  mov   eax,4
  mov   ebx,[__X]
  shl   ebx,16
  add   ebx,[__Y]
  mov   ecx,[__COLOR]
  mov   edx,[__S]
  movzx esi,byte[edx-1]
  int   0x40
end; end;

procedure draw_line(x1,y1,x2,y2,color: integer);
begin asm
  mov   eax,38
  mov   ebx,[__X1]
  shl   ebx,16
  add   ebx,[__X2]
  mov   ecx,[__Y1]
  shl   ecx,16
  add   ecx,[__Y2]
  mov   edx,[__COLOR]
  int   0x40
end; end;

function get_skin_height: integer;
begin asm
  mov  eax,48
  mov  ebx,4
  int  0x40
  mov  [.__RESULT],eax
end; end;

procedure draw_rect(x1,y1,x2,y2,color: integer);
begin
  draw_line(x1,y1,x1,y2,color);
  draw_line(x2,y1,x2,y2,color);
  draw_line(x1,y1,x2,y1,color);
  draw_line(x1,y2,x2,y2,color);
end;

procedure delete_button(id: integer);
begin asm
    mov   eax,8
    mov   edx,[__ID]
    add   edx,0x80000000
    int   0x40
end; end;

procedure image(s: string);
begin asm
mov eax,7
mov ebx,[__S]
mov ecx,161*65536+119
mov edx,161*65536+119
int 0x40
end; end;



